#include "mainwindow.h"

RemovePunchHoles::RemovePunchHoles(QWidget *parent) :
    QComboBox(parent)
{
    changed = false;
}

void RemovePunchHoles::initialize(){
    changed = true;
}


//
// Temporary supports only chinise
//
void RemovePunchHoles::update_ui(INT_SETTING_VALUE remove_punchhole_para, QLabel* label1, QLabel* label2){

    label1->setText("去除装订孔");

    if (remove_punchhole_para.capability.supportLevel != kSDISupportLevelNone)
    {
        // confirm chinese regin
        auto sampleString = TranslationString::GetString().translation_str.MAINSETTING_003;
        if (sampleString == "自动侦测" || sampleString == "自動偵測")
        {
            this->setVisible(true);
            label1->setVisible(true);
            label2->setVisible(true);
        }else{
            this->setVisible(false);
            label1->setVisible(false);
            label2->setVisible(false);
            return;
        }
    }else
    {
        this->setVisible(true);
        label1->setVisible(false);
        label2->setVisible(false);
        return;
    }

    if(changed == true){
        this->clear();
        if(remove_punchhole_para.capability.supportLevel == kSDISupportLevelAvailable){
            this->setEnabled(true);
            label1->setVisible(true);
            label2->setVisible(true);

            this->add_item(remove_punchhole_para.capability.list, remove_punchhole_para.capability.countOfList);
            this->select_item(remove_punchhole_para);
        }else {
            this->setEnabled(false);
            label1->setVisible(false);
            label2->setVisible(false);
        }
        changed = false;
    }
}

//
// Temporary supports only chinise
//
void RemovePunchHoles::add_item(int32_t item_list[], int32_t list_size){

    int i = 0;
    while(i < list_size){
        if(item_list[i] == RemovePunchHoleNone){
            this->insertItem(i, "关", RemovePunchHoleNone);
        }else if(item_list[i] == RemovePunchHoleLeftRight){
            this->insertItem(i, "左右", RemovePunchHoleLeftRight);
        }else if(item_list[i] == RemovePunchHoleTopBottom){
            this->insertItem(i, "上下", RemovePunchHoleTopBottom);
        }else if(item_list[i] == RemovePunchHoleAll){
            this->insertItem(i, "所有边缘", RemovePunchHoleAll);
        }
        i++;
    }
}

void RemovePunchHoles::select_item(INT_SETTING_VALUE remove_punchhole_para){

    int list_size = remove_punchhole_para.capability.countOfList;

    int i = 0;
    while(i < list_size){
        if(remove_punchhole_para.capability.list[i] == remove_punchhole_para.select){
            this->setCurrentIndex(i);
        }
        i++;
    }
}

void RemovePunchHoles::item_event(int value, INT_SETTING_VALUE* remove_punchhole_para)
{
    QVariant select_item = this->itemData(value);

    if(select_item == RemovePunchHoleNone){
        remove_punchhole_para->select = RemovePunchHoleNone;
    }else if(select_item == RemovePunchHoleLeftRight){
        remove_punchhole_para->select = RemovePunchHoleLeftRight;
    }else if(select_item == RemovePunchHoleTopBottom){
        remove_punchhole_para->select = RemovePunchHoleTopBottom;
    }else if(select_item == RemovePunchHoleAll){
        remove_punchhole_para->select = RemovePunchHoleAll;
    }
    changed = true;
}
